import { PropertyValues } from "lit";
import { ElementDefinitionsMap, FtLitElement } from "@fluid-topics/ft-wc-utils";
import { FtSelectOptionProperties, FtSelectProperties } from "./ft-select.properties";
export declare class FtSelectOption extends FtLitElement implements FtSelectOptionProperties {
    static elementDefinitions: ElementDefinitionsMap;
    label: string;
    value: any;
    selected: boolean;
    protected render(): import("lit").TemplateResult<1>;
    protected update(changedProperties: PropertyValues): void;
}
export declare class FtSelect extends FtLitElement implements FtSelectProperties {
    static elementDefinitions: ElementDefinitionsMap;
    static styles: import("lit").CSSResult[];
    label: string;
    ariaLabel: string;
    helper: string;
    outlined: boolean;
    disabled: boolean;
    error: boolean;
    fixedMenuPosition: boolean;
    options: Array<FtSelectOptionProperties>;
    selectedOption?: FtSelectOptionProperties;
    private optionsDisplayed;
    private focusOptions;
    private container?;
    private optionsMenu?;
    private mainPanel;
    private firstOption?;
    private focusedOption?;
    private selectedOptionElement?;
    private lastOption?;
    private optionsSlot?;
    protected render(): import("lit").TemplateResult<1>;
    private renderOption;
    protected update(props: PropertyValues): void;
    protected contentAvailableCallback(props: PropertyValues): void;
    private get hasOptionsMenuOpen();
    private get hasOptions();
    private updateOptionsFromSlot;
    private onMainPanelKeyDown;
    private onOptionsKeyDown;
    private onOptionKeyDown;
    private selectOption;
    private hideOptions;
    connectedCallback(): void;
    disconnectedCallback(): void;
}
